Faire un WD "a la tds" suite a QR R3

History

#1 - 28/01/2016 02:02 PM - bruno katra

Ben effectivement, j'ai implémenté quelque-chose, mais je ne vois toujours pas bien I'utilité.

La tache LOAD arme un timer qui doit se déclencher 1.1 seconde aprés son lancement (timer hardware, pas software, c'est a dire géré par I'lP core
gptimer du VHDL, pas par RTEMS). La tache LOAD s'endort pour1 seconde. A son réveil, elle recharge le timer, qui normalement n'a pas lancé la

routine a laquelle il est attaché puisqu'il ne s'est pas écoulé 1.1 secondes. Si le systeme est bloqué, alors LOAD ne se réveille pas et la routine
attachée au timer est lancée.

Question: que soit faire la routine attachée au timer? Autre question: la routine sera-t-elle exécutée si le systeme est planté au point de ne pas
permettre a LOAD de se réveiller?

Voila, j'ai implémenté ce qu'a implémenté TDS je crois, mais c'est a affiner.
Le 25/01/2016 13:44, Bruno Katra a écrit :

Salut Paul, j'ai vu le changelog de la 3.0.0.13 : concernant le watchdog, lors de la revue QR R3 (la 1ére : celle au CNES) vous aviez parlé avec
Philippe de I'implémentation du watchdog et de la fagon de le faire car a priori sans intérét. A la fin de votre discussion ou vous aviez évoqué
TDS, Philippe avait expliqué comment TDS faisait et dit que I'on pourrait faire pareil (cf. bilan QR ci-dessous). Cette discussion dépassait un
peu mon niveau de compréhension mais ¢a avait I'air de te parler. Ma question donc : un watchdog "a la TDS" c'est quoi ?

Pas la peine de répondre de suite, on pourra causer de ¢a mercredi.

Merci

A+

#2 - 28/01/2016 02:02 PM - bruno katra

Bonjour Bruno,

Le 28 janvier 2016 a 08:56, Bruno Katra <bruno.katra@Ipp.polytechnique.fr> a écrit :

Bonjour Philippe, durant la QR R3, Paul et toi avez échangé sur la pertinence et la maniere d'implémenter un w
atchdog au niveau software sur LFR. Il avait été conclu de faire quelque chose "comme TDS". Voici ce que Paul
est en train d'implémenter, cela convient-il?

"La tache LOAD (priorité la plus haute) arme un timer qui doit se déclencher 1.1 seconde apres son lancement (timer hardware, pas software, c'est a
dire géré par I'lP core gptimer du VHDL, pas par RTEMS). La tache LOAD s'endort pour 1 seconde. A son réveil, elle recharge le timer, qui
normalement n'a pas lancé la routine a laquelle il est attaché puisqu'il ne s'est pas écoulé 1.1 secondes. Si le systéme est bloqué, alors LOAD ne se
réveille pas et la routine attachée au timer est lancée : cette routine fait un exit(0) (comme la TC_LFR_RESET)."

Merci d'avance et bonne journée

Le concept est bon excepté un point : la tache LOAD doit avoir la priorité la plus basse, sinon le systéme ne sera pas a méme de détecter une boucle
sans fin dans une des taches moins prioritaires. Si, par exemple, la tache de transmission des TM est bloquée, alors le watchdog ne sera jamais
déclenché car toujours réarmé par la tache LOAD.

En donnant a la tache LOAD la priorité la plus basse, il faut aussi bien évaluer la période de déclenchement du timer HW et donc évaluer la durée
max pendant laquelle une tache plus prioritaire que la tache LOAD peut étre activée. 1.1 s me parait trop court : on peut avoir une période d'une
dizaine de secondes, ce n'est pas génant. La période de la tache LOAD peut elle restée configurée a 1 seconde.

A bientét,

Philippe
Bruno

#3 - 28/01/2016 02:03 PM - bruno katra
- Status changed from New to In Progress
- Assignee set to paul leroy

- % Done changed from 0 to 50

#4 - 01/02/2016 03:28 PM - paul leroy

- Assignee changed from paul leroy to bruno katra

J'ai modifié le fonctionnement:

Le timer matériel affecté au watchdog a une durée de 10 secondes. Il est réarmé toutes les secondes par la tache LOAD qui a une priorité trés basse.

En cas de perte de lien prolongée, la tache LINK (tache de haute priorité qui s'occupe d'attendre que le lien revienne) s'occupe de le recharger. La
tache LINK se rendort et repasse la main a la tache LOAD si le lien revient.

#5 - 02/03/2016 02:45 PM - bruno katra
- Status changed from In Progress to Closed

- % Done changed from 50 to 100

fait dans SRS 2.0
